<?php
require('tfpdf.php');
class PDF_Grid extends tFPDF {
	var $grid = false;
	var $logo = "";
	var $logox = 0;
	var $logoy = 0;
	var $logow = 0;
	var $logoh = 0;
	var $showfooter = false;

	function setlogo($image)	{
		$this->logo = $image;
	}
	function showfooter($show)	{
		$this->showfooter = $show;
	}

	function DrawGrid(){
		if($this->grid===true){
			$spacing = 5;
		} else {
			$spacing = $this->grid;
		}
		$this->SetDrawColor(204,255,255);
		$this->SetLineWidth(0.35);
		for($i=0;$i<$this->w;$i+=$spacing){
			$this->Line($i,0,$i,$this->h);
		}
		for($i=0;$i<$this->h;$i+=$spacing){
			$this->Line(0,$i,$this->w,$i);
		}
		$this->SetDrawColor(0,0,0);

		$x = $this->GetX();
		$y = $this->GetY();
		$this->SetFont('Arial','I',8);
		$this->SetTextColor(204,204,204);
		for($i=20;$i<$this->h;$i+=20){
			$this->SetXY(1,$i-3);
			$this->Write(4,$i);
		}
		for($i=20;$i<(($this->w)-($this->rMargin)-10);$i+=20){
			$this->SetXY($i-1,1);
			$this->Write(4,$i);
		}
		$this->SetXY($x,$y);
	}

	function Header()	{
		if($this->grid)
			$this->DrawGrid();
    //$this->SetXY(0,0);
    // Logo
    if ($this->logo != ""){
    	$this->Image($this->logo,$this->logox,$this->logoy,$this->logow,$this->logoh);
    }
    //$this->SetXY(0,0);
    // Arial bold 12
    //$this->SetFont('Arial','B',15);
    // Move to the right
    //$this->Cell(80);
    // Title
    //$this->Cell(30,10,'Title',1,0,'C');
    // Line break
    //$this->Ln(20);
	}
	// Page footer
	function Footer()	{
		if ($this->showfooter === true){
			// Position at 1.5 cm from bottom
	  	$this->SetY(-15);
		  // Arial italic 8
		  $this->SetFont('Courier','I',8);
	  	// Page number
	  	$this->Cell(0,10,'Page '.$this->PageNo().'/{nb}',0,0,'C');
	  }
	}

}


$pdf = new PDF_Grid();
$pdf->AliasNbPages();
$pdf->grid = false;
$logox = 0;
$logoy = 0;
$logow = 0;
$logoh = 0;
$logoimage = "";
$charset="ISO-8859-1";
// Add a Unicode font (uses UTF-8)
$pdf->AddFont('DejaVu','','DejaVuSansCondensed.ttf',true);
$pdf->SetFont('DejaVu','',14);


$br = "<br />";
$json= '[{"action":"init","grid":5},{"style":"","action":"Setfont","font":"courier","size":12},{"action":"NewPage"},{"w":72,"g":64,"text":"this is a text","b":64,"r":64,"align":"L","action":"SetText","border":"LBR","h":10,"y":5,"x":5}]';
if (isset($_REQUEST['DeviceID'])){$DeviceID=trim($_REQUEST['DeviceID']);} else {$DeviceID="0";}
if (isset($_REQUEST['json'])){$json=stripcslashes(trim($_REQUEST['json']));}

$file_handle = fopen('./b4a.log', 'a+');
fwrite($file_handle, "======================================"."\r\n");
foreach($_REQUEST as $name => $value){
	if ($name != "manbild"){
		$add = "";
		fwrite($file_handle, date("d.m.Y H:i:s", time()).": ".$name."=".$value." ".$add."\r\n");
	}
}
fwrite($file_handle, "======================================"."\r\n");

#echo "DeviceID = ".$DeviceID.$br;
#echo "json = ".$json.$br;

$jsonarr = json_decode($json, true);
foreach(json_decode($json, true) as $action) {
	if (trim($action['action']) != ""){
		#echo "Action = ".trim(strtolower($action['action'])).$br;
		#echo "=================================".$br;
		$todo = trim(strtolower($action['action']));
		if ($todo == "init"){
			#echo "GridSize = ".intval(trim(strtolower($action['grid']))).$br;
			if (intval(trim(strtolower($action['grid']))) > 0){
				$pdf->grid = true;
				$pdf->grid = intval(trim(strtolower($action['grid'])));
				#echo "GridSize = ".$pdf->grid.$br;
			}
			if (isset($action['showfooter'])){
				if (intval($action['showfooter']) == 1){
					$pdf->showfooter = true;
				} else {
					$pdf->showfooter = false;
				}
			}
			if(isset($action['charset'])){
				$charset=$action['charset'];
			} else {
				$charset="ISO-8859-1";
			}

			foreach($action AS $fname => $fvalue){
				#echo $fname." = ".$fvalue.$br;
			}
		}
		if ($todo == "setlogo"){
			#echo "GridSize = ".intval(trim(strtolower($action['grid']))).$br;
			foreach($action AS $fname => $fvalue){
				if (strtolower($fname) == "x"){
					$logox = intval($fvalue);
				} elseif (strtolower($fname) == "y"){
					$logoy = intval($fvalue);
				} elseif (strtolower($fname) == "w"){
					$logow = intval($fvalue);
				} elseif (strtolower($fname) == "h"){
					$logoh = intval($fvalue);
				} elseif (strtolower($fname) == "image"){
					if (file_exists($fvalue)) {
  					$logoimage = $fvalue;
					}
				} elseif (strtolower($fname) == "action"){
				}else{
					#echo strtolower($fname)." = ".$fvalue.$br;
				}
			}
			#echo "x = ".$logox.$br;
			#echo "y = ".$logoy.$br;
			#echo "w = ".$logow.$br;
			#echo "h = ".$logoh.$br;
			#echo "image = ".$logoimage.$br;
	  	$pdf->setlogo($logoimage);
			#echo "image = ".$pdf->logo.$br;
			$pdf->logox = $logox;
			$pdf->logoy = $logoy;
			$pdf->logow = $logow;
			$pdf->logoh = $logoh;
			#foreach($action AS $fname => $fvalue){
			#	echo $fname." = ".$fvalue."<br />";
			#}
		}
		if ($todo == "line"){
			$pdf->line(intval($action['x1']),intval($action['y1']),intval($action['x2']),intval($action['y2']));
		}
		if ($todo == "setdrawcolor"){
			$pdf->SetDrawColor(intval($action['r']),intval($action['g']),intval($action['b']));
		}
		if ($todo == "setfillcolor"){
			$pdf->SetFillColor(intval($action['r']),intval($action['g']),intval($action['b']));
		}
		if ($todo == "rect"){
			$pdf->rect(intval($action['x']),intval($action['y']),intval($action['w']),intval($action['h']),intval($action['style']) );
		}
		if ($todo == "newpage"){
			$pdf->AddPage();
			$pdf->SetXY(0,0);
		}
		if ($todo == "newline"){
			$pdf->ln(intval($action['height']));
		}
		if ($todo  == "setfont"){
			if($action['font'] != ""){
				#echo "SetFont(".$action['font'].",".$action['style'].",".$action['size'].")";
				$pdf->SetFont($action['font'],$action['style'],$action['size']);
			}
		}
		if ($todo == "settext"){
			if(isset($action['text'])){
				
				#echo "SetText(".$action['x'].",".$action['y'].",".$action['text'].")";
				#$pdf->cell(intval($action['x']));
				
				$pdf->SetXY(intval($action['x']),intval($action['y']));
				$pdf->SetTextColor(intval($action['r']),intval($action['g']),intval($action['b']));
				#$pdf->Cell(intval($action['w']),intval($action['h']),iconv("UTF-8", $charset, $action['text']),$action['border'],0,$action['align']);
				$pdf->Cell(intval($action['w']),intval($action['h']),$action['text'],$action['border'],0,$action['align']);
			}
		}
		if ($todo == "setauthor"){
			if(isset($action['author'])){
				$pdf->SetAuthor($action['author'],true);
			}
		}
		if ($todo == "setcharset"){
			if(isset($action['charset'])){
				$charset=$action['charset'];
			} else {
				$charset="ISO-8859-1";
			}
		}
		if ($todo == "setcreator"){
			if(isset($action['creator'])){
				$pdf->SetCreator($action['creator'],true);
			}
		}
		if ($todo == "setkeywords"){
			if(isset($action['keywords'])){
				$pdf->SetKeywords($action['keywords'],true);
			}
		}
		if ($todo == "setsubject"){
			if(isset($action['subject'])){
				$pdf->SetSubject($action['subject'],true);
			}
		}
		if ($todo == "settitle"){
			if(isset($action['title'])){
				$pdf->SetTitle($action['title'],true);
			}
		}
		if ($todo == "setlinewidth"){
			$pdf->SetLineWidth(intval($action['w']));
		}
		if ($todo == "setleftmargin"){
			$pdf->SetLeftMargin(intval($action['w']));
		}
		if ($todo == "settopmargin"){
			$pdf->SetTopMargin(intval($action['w']));
		}
		if ($todo == "setrightmargin"){
			$pdf->SetRightMargin(intval($action['w']));
		}
		if ($todo == "setimage"){
			$pdf->Image($action['imgurl'],intval($action['x']),intval($action['y']),intval($action['w']),intval($action['h']),$action['type']);
		}
	}
	#echo "<br />";
}
$destination = date("Ymd_His", time()).'_'.$DeviceID.'.pdf';
$pdf->Output('./PDFs/'.$destination);

$res = array();
$res["resultcode"] = 0;
$res["pdf"] = 'http://pdf.basic4android.de/PDFs/'.$destination;
echo json_encode($res);
fclose($file_handle);
#echo '<a href="PDFs/output.pdf" target="_blank">output.pdf</a>';;
?>